rexml - パース時のnamespaceチェックでのエラーについて

02/01/2012 03:47 PM - m-hiramatsu (Miho Hiramatsu)

Status: Closed   

Priority: Normal   

Assignee: kou (Kouhei Sutou)   

Target version: 1.9.3   

ruby -v: ruby 1.9.3p0 (2011-10-30 revision

33570) [i686-linux]

Backport:  

Description

添付のプログラムを実行すると以下のエラーとなります。

（実行環境：CentOS6）

The 'xml' prefix must not be bound to any other namespace (http://www.w3.org/TR/REC-xml-names/#ns-decl)

Line: 7

Position: 477

XMLデータ内の以下の記述に対して、

xmlns:xml="http://www.w3.org/XML/1998/namespace"

「属性"xmlns:xml"のnamespaceが"http://www.w3.org/XML/1998/namespace"でなければエラーとする」というチェックを

/rexml/parsers/baseparser.rb    line:386付近

で実行しているようですが、以下は誤りではないでしょうか。

[baseparser.rbのline:386付近を抜粋]

　　　...略

attrs.each { |a,b,c,d,e|

if b == "xmlns"

if c == "xml"

if d != "http://www.w3.org/XML/1998/namespace"

msg = "The 'xml' prefix must not be bound to any other namespace "+

"(http://www.w3.org/TR/REC-xml-names/#ns-decl)"

raise REXML::ParseException.new( msg, @source, self )

end

　　　...略

if d != "http://www.w3.org/XML/1998/namespace"

本来"d"ではなく"e"と比較すべきではないでしょうか。

Associated revisions

Revision 4f0439617edfff2fa4dbc8b0c07a65bcf37cda53 - 04/17/2012 12:36 PM - naruse (Yui NARUSE)

merge revision(s) 34419: [Backport #6307]

    * lib/rexml/parsers/baseparser.rb, test/rexml/test_namespace.rb:

      fix the default xml namespace URI validation.

      [ruby-dev:45169] [Bug #5956]

      Reported by Miho Hiramatsu. Thanks!!!

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_9_3@35365 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 4f043961 - 04/17/2012 12:36 PM - naruse (Yui NARUSE)

merge revision(s) 34419: [Backport #6307]

    * lib/rexml/parsers/baseparser.rb, test/rexml/test_namespace.rb:

      fix the default xml namespace URI validation.

      [ruby-dev:45169] [Bug #5956]

      Reported by Miho Hiramatsu. Thanks!!!

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_9_3@35365 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
History

#1 - 02/02/2012 09:39 PM - kou (Kouhei Sutou)

- Status changed from Open to Assigned

- Assignee set to kou (Kouhei Sutou)

#2 - 02/02/2012 09:50 PM - kou (Kouhei Sutou)

- Status changed from Assigned to Closed

- % Done changed from 0 to 100

r34419 で修正しました！

再現コードがあってとても助かりました！

ありがとうございます！

#3 - 02/03/2012 10:06 AM - m-hiramatsu (Miho Hiramatsu)

了解です。

最新のスナップショットで問題が発生しないことを確認しました。

すぐの対応ありがとうございました。

Files

rexml_sample.rb 841 Bytes 02/01/2012 m-hiramatsu (Miho Hiramatsu)
